Index: lemon/bits/vector_map.h
===================================================================
--- lemon/bits/vector_map.h	(revision 1996)
+++ lemon/bits/vector_map.h	(revision 1999)
@@ -17,21 +17,19 @@
  */
 
-#ifndef LEMON_VECTOR_MAP_H
-#define LEMON_VECTOR_MAP_H
+#ifndef LEMON_BITS_VECTOR_MAP_H
+#define LEMON_BITS_VECTOR_MAP_H
 
 #include <vector>
 #include <algorithm>
 
+#include <lemon/bits/traits.h>
 #include <lemon/bits/utility.h>
-#include <lemon/bits/map_extender.h>
+
 #include <lemon/bits/alteration_notifier.h>
-#include <lemon/concept_check.h>
-#include <lemon/concept/maps.h>
-
-/// \ingroup graphbits
+
+///\ingroup graphbits
 ///
 ///\file
 ///\brief Vector based graph maps.
-
 namespace lemon {
 
@@ -41,21 +39,17 @@
   ///
   /// The VectorMap template class is graph map structure what
-  /// automatically indates the map when a key is added to or erased from
+  /// automatically updates the map when a key is added to or erased from
   /// the map. This map factory uses the allocators to implement 
   /// the container functionality. This map factory
   /// uses the std::vector to implement the container function.
   ///
-  /// \param Registry The AlterationNotifier that will notify this map.
+  /// \param Notifier The AlterationNotifier that will notify this map.
   /// \param Item The item type of the graph items.
   /// \param Value The value type of the map.
   /// 
-  /// \author Balazs Dezso
-  	
-  template <
-    typename _Graph, 
-    typename _Item,    
-    typename _Value
-    >
-  class VectorMap : public AlterationNotifier<_Item>::ObserverBase {
+  /// \author Balazs Dezso  	
+  template <typename _Graph, typename _Item, typename _Value>
+  class VectorMap 
+    : public ItemSetTraits<_Graph, _Item>::ItemNotifier::ObserverBase {
   private:
 		
@@ -67,4 +61,6 @@
     /// The graph type of the map. 
     typedef _Graph Graph;
+    /// The item type of the map.
+    typedef _Item Item;
     /// The reference map tag.
     typedef True ReferenceMapTag;
@@ -75,31 +71,25 @@
     typedef _Value Value;
 
-    typedef AlterationNotifier<_Item> Registry;
+    /// The notifier type.
+    typedef typename ItemSetTraits<_Graph, _Item>::ItemNotifier Notifier;
 
     /// The map type.
     typedef VectorMap Map;
     /// The base class of the map.
-    typedef typename Registry::ObserverBase Parent;
+    typedef typename Notifier::ObserverBase Parent;
 
     /// The reference type of the map;
     typedef typename Container::reference Reference;
-    /// The pointer type of the map;
-    typedef typename Container::pointer Pointer;
-
-    /// The const value type of the map.
-    typedef const Value ConstValue;
     /// The const reference type of the map;
     typedef typename Container::const_reference ConstReference;
-    /// The pointer type of the map;
-    typedef typename Container::const_pointer ConstPointer;
-
-
-    /// \brief Constructor to attach the new map into the registry.
-    ///
-    /// It constructs a map and attachs it into the registry.
+
+
+    /// \brief Constructor to attach the new map into the notifier.
+    ///
+    /// It constructs a map and attachs it into the notifier.
     /// It adds all the items of the graph to the map.
-    VectorMap(const Graph& _g) : graph(&_g) {
-      attach(_g.getNotifier(_Item()));
-      build();
+    VectorMap(const Graph& graph) {
+      Parent::attach(graph.getNotifier(Item()));
+      container.resize(Parent::getNotifier()->maxId() + 1);
     }
 
@@ -108,7 +98,7 @@
     /// It constructs a map uses a given value to initialize the map. 
     /// It adds all the items of the graph to the map.
-    VectorMap(const Graph& _g, const Value& _v) : graph(&_g) { 
-      attach(_g.getNotifier(_Item()));
-      container.resize(graph->maxId(_Item()) + 1, _v);
+    VectorMap(const Graph& graph, const Value& value) {
+      Parent::attach(graph.getNotifier(Item()));
+      container.resize(Parent::getNotifier()->maxId() + 1, value);
     }
 
@@ -116,35 +106,14 @@
     ///
     /// Copy constructor.
-    VectorMap(const VectorMap& _copy) 
-      : Parent(), graph(_copy.getGraph()) {
+    VectorMap(const VectorMap& _copy) : Parent() {
       if (_copy.attached()) {
-	attach(*_copy.getRegistry());
+	Parent::attach(*_copy.getNotifier());
 	container = _copy.container;
       }
     }
 
-    /// \brief Destrcutor
-    ///
-    /// Destructor.
-    virtual ~VectorMap() {
-      if (attached()) {
-	detach();
-      }
-    }
-
-
   private:
 
     VectorMap& operator=(const VectorMap&);
-
-  protected:
-
-    using Parent::attach;
-    using Parent::detach;
-    using Parent::attached;
-
-    const Graph* getGraph() const {
-      return graph;
-    }
 
   public:
@@ -155,5 +124,5 @@
     /// actual items of the graph.      
     Reference operator[](const Key& key) {
-      return container[graph->id(key)];
+      return container[Parent::getNotifier()->id(key)];
     } 
 		
@@ -163,5 +132,5 @@
     /// actual items of the graph. 
     ConstReference operator[](const Key& key) const {
-      return container[graph->id(key)];
+      return container[Parent::getNotifier()->id(key)];
     }
 
@@ -178,8 +147,8 @@
     /// \brief Adds a new key to the map.
     ///		
-    /// It adds a new key to the map. It called by the observer registry
+    /// It adds a new key to the map. It called by the observer notifier
     /// and it overrides the add() member function of the observer base.     
     virtual void add(const Key& key) {
-      int id = graph->id(key);
+      int id = Parent::getNotifier()->id(key);
       if (id >= (int)container.size()) {
 	container.resize(id + 1);
@@ -189,35 +158,48 @@
     /// \brief Adds more new keys to the map.
     ///		
-    /// It adds more new keys to the map. It called by the observer registry
+    /// It adds more new keys to the map. It called by the observer notifier
     /// and it overrides the add() member function of the observer base.     
     virtual void add(const std::vector<Key>& keys) {
+      int max = container.size() - 1;
       for (int i = 0; i < (int)keys.size(); ++i) {
-	add(keys[i]);
-      }
+        int id = Parent::getNotifier()->id(keys[i]);
+        if (id >= max) {
+          max = id;
+        }
+      }
+      container.resize(max + 1);
     }
 
     /// \brief Erase a key from the map.
     ///
-    /// Erase a key from the map. It called by the observer registry
+    /// Erase a key from the map. It called by the observer notifier
     /// and it overrides the erase() member function of the observer base.     
-    virtual void erase(const Key&) {}
+    virtual void erase(const Key& key) {
+      container[Parent::getNotifier()->id(key)] = Value();
+    }
 
     /// \brief Erase more keys from the map.
     ///
-    /// Erase more keys from the map. It called by the observer registry
+    /// Erase more keys from the map. It called by the observer notifier
     /// and it overrides the erase() member function of the observer base.     
-    virtual void erase(const std::vector<Key>&) {}
+    virtual void erase(const std::vector<Key>& keys) {
+      for (int i = 0; i < (int)keys.size(); ++i) {
+	container[Parent::getNotifier()->id(keys[i])] = Value();
+      }
+    }
     
     /// \brief Buildes the map.
     ///	
-    /// It buildes the map. It called by the observer registry
+    /// It buildes the map. It called by the observer notifier
     /// and it overrides the build() member function of the observer base.
     virtual void build() { 
-      container.resize(graph->maxId(_Item()) + 1);
+      int size = Parent::getNotifier()->maxId() + 1;
+      container.reserve(size);
+      container.resize(size);
     }
 
     /// \brief Clear the map.
     ///
-    /// It erase all items from the map. It called by the observer registry
+    /// It erase all items from the map. It called by the observer notifier
     /// and it overrides the clear() member function of the observer base.     
     virtual void clear() { 
@@ -228,5 +210,4 @@
 		
     Container container;
-    const Graph *graph;
 
   };
Index: lemon/concept/graph_component.h
===================================================================
--- lemon/concept/graph_component.h	(revision 1993)
+++ lemon/concept/graph_component.h	(revision 1999)
@@ -738,11 +738,13 @@
     /// be registered into the notifier and whenever an alteration
     /// occured in the graph all the observers will notified about it.
-    class AlterableGraphComponent : virtual public BaseGraphComponent {
+    class AlterableGraphComponent : virtual public BaseIterableGraphComponent {
     public:
 
       /// The edge observer registry.
-      typedef AlterationNotifier<Edge> EdgeNotifier;
+      typedef AlterationNotifier<AlterableGraphComponent, Edge> 
+      EdgeNotifier;
       /// The node observer registry.
-      typedef AlterationNotifier<Node> NodeNotifier;
+      typedef AlterationNotifier<AlterableGraphComponent, Node> 
+      NodeNotifier;
       
       /// \brief Gives back the edge alteration notifier.
Index: lemon/dag_shortest_path.h
===================================================================
--- lemon/dag_shortest_path.h	(revision 1993)
+++ lemon/dag_shortest_path.h	(revision 1999)
@@ -330,5 +330,5 @@
     typedef typename _Traits::OperationTraits OperationTraits;
     /// \brief The Node weight map.
-    typedef typename Graph::NodeMap<Value> WeightMap;
+    typedef typename Graph::template NodeMap<Value> WeightMap;
   private:
     /// Pointer to the underlying graph
Index: lemon/edge_set.h
===================================================================
--- lemon/edge_set.h	(revision 1990)
+++ lemon/edge_set.h	(revision 1999)
@@ -572,5 +572,9 @@
     typedef typename Parent::NodesImplBase NodesImplBase;
 
-    void eraseNode(const Node&) {
+    void eraseNode(const Node& node) {
+      if (Parent::InEdgeIt(*this, node) == INVALID &&
+          Parent::OutEdgeIt(*this, node) == INVALID) {
+        return;
+      }
       throw UnsupportedOperation();
     }
@@ -663,5 +667,8 @@
     typedef typename Parent::NodesImplBase NodesImplBase;
 
-    void eraseNode(const Node&) {
+    void eraseNode(const Node& node) {
+      if (Parent::IncEdgeIt(*this, node) == INVALID) {
+        return;
+      }
       throw UnsupportedOperation();
     }
Index: lemon/full_graph.h
===================================================================
--- lemon/full_graph.h	(revision 1995)
+++ lemon/full_graph.h	(revision 1999)
@@ -22,7 +22,6 @@
 #include <cmath>
 
-
+#include <lemon/bits/base_extender.h>
 #include <lemon/bits/graph_extender.h>
-
 
 #include <lemon/bits/invalid.h>
Index: lemon/graph_adaptor.h
===================================================================
--- lemon/graph_adaptor.h	(revision 1993)
+++ lemon/graph_adaptor.h	(revision 1999)
@@ -31,4 +31,5 @@
 #include <lemon/maps.h>
 
+#include <lemon/bits/base_extender.h>
 #include <lemon/bits/graph_adaptor_extender.h>
 #include <lemon/bits/graph_extender.h>
@@ -938,5 +939,5 @@
 
     UndirGraphAdaptorBase() 
-      : Parent(), edge_notifier(), edge_notifier_proxy(edge_notifier) {}
+      : edge_notifier(*this), edge_notifier_proxy(edge_notifier) {}
 
     void setGraph(_Graph& graph) {
@@ -948,5 +949,9 @@
 
     ~UndirGraphAdaptorBase() {
-      getNotifier(Edge()).clear();
+      edge_notifier.clear();
+    }
+
+    int maxId(typename Parent::Edge) const {
+      return Parent::maxEdgeId();
     }
 
@@ -959,5 +964,5 @@
     using Parent::getNotifier;
 
-    typedef AlterationNotifier<Edge> EdgeNotifier;
+    typedef AlterationNotifier<UndirGraphAdaptorBase, Edge> EdgeNotifier;
     EdgeNotifier& getNotifier(Edge) const { return edge_notifier; }
 
Index: lemon/graph_utils.h
===================================================================
--- lemon/graph_utils.h	(revision 1993)
+++ lemon/graph_utils.h	(revision 1999)
@@ -1190,6 +1190,6 @@
       Map::build();
       Item it;
-      const typename Map::Graph* graph = Map::getGraph(); 
-      for (graph->first(it); it != INVALID; graph->next(it)) {
+      const typename Map::Notifier* notifier = Map::getNotifier(); 
+      for (notifier->first(it); it != INVALID; notifier->next(it)) {
 	Map::set(it, invMap.size());
 	invMap.push_back(it);	
@@ -1498,5 +1498,6 @@
   template <typename _Graph>
   class InDegMap  
-    : protected AlterationNotifier<typename _Graph::Edge>::ObserverBase {
+    : protected ItemSetTraits<_Graph, typename _Graph::Edge>
+      ::ItemNotifier::ObserverBase {
 
   public:
@@ -1505,4 +1506,7 @@
     typedef int Value;
     typedef typename Graph::Node Key;
+
+    typedef typename ItemSetTraits<_Graph, typename _Graph::Edge>
+    ::ItemNotifier::ObserverBase Parent;
 
   private:
@@ -1534,15 +1538,9 @@
     /// Constructor for creating in-degree map.
     InDegMap(const Graph& _graph) : graph(_graph), deg(_graph) {
-      AlterationNotifier<typename _Graph::Edge>
-	::ObserverBase::attach(graph.getNotifier(typename _Graph::Edge()));
+      Parent::attach(graph.getNotifier(typename _Graph::Edge()));
       
       for(typename _Graph::NodeIt it(graph); it != INVALID; ++it) {
 	deg[it] = countInEdges(graph, it);
       }
-    }
-
-    virtual ~InDegMap() {
-      AlterationNotifier<typename _Graph::Edge>::
-	ObserverBase::detach();
     }
     
@@ -1612,7 +1610,11 @@
   template <typename _Graph>
   class OutDegMap  
-    : protected AlterationNotifier<typename _Graph::Edge>::ObserverBase {
-
-  public:
+    : protected ItemSetTraits<_Graph, typename _Graph::Edge>
+      ::ItemNotifier::ObserverBase {
+
+  public:
+
+    typedef typename ItemSetTraits<_Graph, typename _Graph::Edge>
+    ::ItemNotifier::ObserverBase Parent;
     
     typedef _Graph Graph;
@@ -1647,6 +1649,5 @@
     /// Constructor for creating out-degree map.
     OutDegMap(const Graph& _graph) : graph(_graph), deg(_graph) {
-      AlterationNotifier<typename _Graph::Edge>
-	::ObserverBase::attach(graph.getNotifier(typename _Graph::Edge()));
+      Parent::attach(graph.getNotifier(typename _Graph::Edge()));
       
       for(typename _Graph::NodeIt it(graph); it != INVALID; ++it) {
@@ -1655,9 +1656,4 @@
     }
 
-    virtual ~OutDegMap() {
-      AlterationNotifier<typename _Graph::Edge>::
-	ObserverBase::detach();
-    }
-    
     /// Gives back the out-degree of a Node.
     int operator[](const Key& key) const {
Index: lemon/grid_ugraph.h
===================================================================
--- lemon/grid_ugraph.h	(revision 1993)
+++ lemon/grid_ugraph.h	(revision 1999)
@@ -24,4 +24,5 @@
 #include <lemon/bits/utility.h>
 
+#include <lemon/bits/base_extender.h>
 #include <lemon/bits/graph_extender.h>
 
Index: lemon/list_graph.h
===================================================================
--- lemon/list_graph.h	(revision 1995)
+++ lemon/list_graph.h	(revision 1999)
@@ -24,4 +24,5 @@
 ///\brief ListGraph, ListUGraph classes.
 
+#include <lemon/bits/base_extender.h>
 #include <lemon/bits/graph_extender.h>
 
@@ -321,7 +322,9 @@
   ///\sa concept::ErasableGraph.
 
-  class ListGraph : public ExtendedListGraphBase 
-  {
+  class ListGraph : public ExtendedListGraphBase {
   public:
+
+    typedef ExtendedListGraphBase Parent;
+
     /// Changes the target of \c e to \c n
 
@@ -447,6 +450,6 @@
     ///\warning Edge and node deletions cannot be restored.
     ///\warning Snapshots cannot be nested.
-    class Snapshot : protected AlterationNotifier<Node>::ObserverBase,
-		     protected AlterationNotifier<Edge>::ObserverBase
+    class Snapshot : protected Parent::NodeNotifier::ObserverBase,
+		     protected Parent::EdgeNotifier::ObserverBase
     {
     public:
@@ -460,5 +463,5 @@
             
 
-      protected:
+    protected:
       
       ListGraph *g;
@@ -491,15 +494,11 @@
       void regist(ListGraph &_g) {
 	g=&_g;
-	AlterationNotifier<Node>::ObserverBase::
-	  attach(g->getNotifier(Node()));
-	AlterationNotifier<Edge>::ObserverBase::
-	  attach(g->getNotifier(Edge()));
+	Parent::NodeNotifier::ObserverBase::attach(g->getNotifier(Node()));
+	Parent::EdgeNotifier::ObserverBase::attach(g->getNotifier(Edge()));
       }
             
       void deregist() {
-	AlterationNotifier<Node>::ObserverBase::
-	  detach();
-	AlterationNotifier<Edge>::ObserverBase::
-	  detach();
+	Parent::NodeNotifier::ObserverBase::detach();
+	Parent::EdgeNotifier::ObserverBase::detach();
 	g=0;
       }
Index: lemon/matrix_maps.h
===================================================================
--- lemon/matrix_maps.h	(revision 1993)
+++ lemon/matrix_maps.h	(revision 1999)
@@ -210,7 +210,8 @@
   template <typename _Graph, typename _Item, typename _Value>
   class DynamicMatrixMap 
-    : protected AlterationNotifier<_Item>::ObserverBase {
-  public:
-    typedef typename AlterationNotifier<_Item>::ObserverBase Parent;
+    : protected ItemSetTraits<_Graph, _Item>::ItemNotifier::ObserverBase {
+  public:
+    typedef typename ItemSetTraits<_Graph, _Item>::ItemNotifier::ObserverBase 
+    Parent;
 
     typedef _Graph Graph;
@@ -236,6 +237,6 @@
     /// Creates an item matrix for the given graph.
     DynamicMatrixMap(const Graph& _graph) 
-      : graph(_graph), values(size(_graph.maxId(Key()) + 1)) {
-      Parent::attach(graph.getNotifier(Key()));
+      : values(size(_graph.maxId(Key()) + 1)) {
+      Parent::attach(_graph.getNotifier(Key()));
     }
 
@@ -245,12 +246,6 @@
     /// pairs of keys the given parameter.
     DynamicMatrixMap(const Graph& _graph, const Value& _val) 
-      : graph(_graph), values(size(_graph.maxId(Key()) + 1), _val) {
-      Parent::attach(graph.getNotifier(Key()));
-    }
-
-    ~DynamicMatrixMap() {
-      if (Parent::attached()) {
-	Parent::detach();
-      }
+      : values(size(_graph.maxId(Key()) + 1), _val) {
+      Parent::attach(_graph.getNotifier(Key()));
     }
 
@@ -260,5 +255,6 @@
     /// Gives back the value assigned to the \c first - \c second ordered pair.
     ConstReference operator()(const Key& first, const Key& second) const {
-      return values[index(graph.id(first), graph.id(second))];
+      return values[index(Parent::getNotifier()->id(first), 
+                          Parent::getNotifier()->id(second))];
     }
     
@@ -268,5 +264,6 @@
     /// Gives back the value assigned to the \c first - \c second ordered pair.
     Reference operator()(const Key& first, const Key& second) {
-      return values[index(graph.id(first), graph.id(second))];
+      return values[index(Parent::getNotifier()->id(first), 
+                          Parent::getNotifier()->id(second))];
     }
 
@@ -275,5 +272,6 @@
     /// Setter function for the matrix map.
     void set(const Key& first, const Key& second, const Value& val) {
-      values[index(graph.id(first), graph.id(second))] = val;
+      values[index(Parent::getNotifier()->id(first), 
+                   Parent::getNotifier()->id(second))] = val;
     }
 
@@ -293,6 +291,6 @@
 
     virtual void add(const Key& key) {
-      if (size(graph.id(key) + 1) >= (int)values.size()) {
-	values.resize(size(graph.id(key) + 1));	
+      if (size(Parent::getNotifier()->id(key) + 1) >= (int)values.size()) {
+	values.resize(size(Parent::getNotifier()->id(key) + 1));	
       }
     }
@@ -301,5 +299,5 @@
 
     virtual void build() {
-      values.resize(size(graph.maxId(Key()) + 1));
+      values.resize(size(Parent::getNotifier()->maxId() + 1));
     }
 
@@ -309,5 +307,4 @@
     
   private:
-    const Graph& graph;
     std::vector<Value> values;
   };
@@ -321,7 +318,8 @@
   template <typename _Graph, typename _Item, typename _Value>
   class DynamicSymMatrixMap 
-    : protected AlterationNotifier<_Item>::ObserverBase {
-  public:
-    typedef typename AlterationNotifier<_Item>::ObserverBase Parent;
+    : protected ItemSetTraits<_Graph, _Item>::ItemNotifier::ObserverBase {
+  public:
+    typedef typename ItemSetTraits<_Graph, _Item>::ItemNotifier::ObserverBase 
+    Parent;
 
     typedef _Graph Graph;
@@ -347,6 +345,6 @@
     /// Creates an item matrix for the given graph.
     DynamicSymMatrixMap(const Graph& _graph) 
-      : graph(_graph), values(size(_graph.maxId(Key()) + 1)) {
-      Parent::attach(graph.getNotifier(Key()));
+      : values(size(_graph.maxId(Key()) + 1)) {
+      Parent::attach(_graph.getNotifier(Key()));
     }
 
@@ -356,12 +354,6 @@
     /// pairs of keys the given parameter.
     DynamicSymMatrixMap(const Graph& _graph, const Value& _val) 
-      : graph(_graph), values(size(_graph.maxId(Key()) + 1), _val) {
-      Parent::attach(graph.getNotifier(Key()));
-    }
-
-    ~DynamicSymMatrixMap() {
-      if (Parent::attached()) {
-	Parent::detach();
-      }
+      : values(size(_graph.maxId(Key()) + 1), _val) {
+      Parent::attach(_graph.getNotifier(Key()));
     }
 
@@ -372,5 +364,6 @@
     /// pair.
     ConstReference operator()(const Key& first, const Key& second) const {
-      return values[index(graph.id(first), graph.id(second))];
+      return values[index(Parent::getNotifier()->id(first), 
+                          Parent::getNotifier()->id(second))];
     }
     
@@ -381,5 +374,6 @@
     /// pair.
     Reference operator()(const Key& first, const Key& second) {
-      return values[index(graph.id(first), graph.id(second))];
+      return values[index(Parent::getNotifier()->id(first), 
+                          Parent::getNotifier()->id(second))];
     }
 
@@ -388,5 +382,6 @@
     /// Setter function for the matrix map.
     void set(const Key& first, const Key& second, const Value& val) {
-      values[index(graph.id(first), graph.id(second))] = val;
+      values[index(Parent::getNotifier()->id(first), 
+                   Parent::getNotifier()->id(second))] = val;
     }
 
@@ -406,6 +401,6 @@
 
     virtual void add(const Key& key) {
-      if (size(graph.id(key) + 1) >= (int)values.size()) {
-	values.resize(size(graph.id(key) + 1));	
+      if (size(Parent::getNotifier()->id(key) + 1) >= (int)values.size()) {
+	values.resize(size(Parent::getNotifier()->id(key) + 1));	
       }
     }
@@ -414,5 +409,5 @@
 
     virtual void build() {
-      values.resize(size(graph.maxId(Key()) + 1));
+      values.resize(size(Parent::getNotifier()->maxId() + 1));
     }
 
@@ -422,5 +417,4 @@
     
   private:
-    const Graph& graph;
     std::vector<Value> values;
   };
Index: lemon/smart_graph.h
===================================================================
--- lemon/smart_graph.h	(revision 1995)
+++ lemon/smart_graph.h	(revision 1999)
@@ -28,4 +28,5 @@
 #include <lemon/bits/invalid.h>
 
+#include <lemon/bits/base_extender.h>
 #include <lemon/bits/graph_extender.h>
 
Index: lemon/xy.h
===================================================================
--- lemon/xy.h	(revision 1993)
+++ lemon/xy.h	(revision 1999)
@@ -151,4 +151,13 @@
 
     };
+
+  ///Returns an xy 
+
+  ///Returns an xy
+  ///\relates xy
+  template <typename T>
+  inline xy<T> make_xy(const T& x, const T& y) {
+    return xy<T>(x, y);
+  }
 
   ///Returns a vector multiplied by a scalar
